#include <iostream>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "circle.h"
#include "assert.h"
#include "ezwin.h"
#include "bitmap.h"
#define LENGTH 25.0
#define HEIGHT 15.0
#define LENGTHINT 25

using namespace std;

int m,p,i=0,k,l,r=0,u,v,x=40,reached=0,score=0;
int left1[10],bullets[10],random1[2];
float angle,canonx,canony,j;
float soldierx[10],soldiery[10],bulletx[10],bullety[10],bulleta[10];

void startwindow();
void endwindow();

SimpleWindow initialwindow("Paratroopers",LENGTH,HEIGHT,Position(0.0,0.0));

void game()
{   
	/*BitMap Photo1(initialwindow);//load the background photo
	Photo1.Load("Back.bmp");
	assert(Photo1.GetStatus()==BitMapOkay);
	Position Photo1Position=(0.0,0.0);
	Photo1.SetPosition(Photo1Position);
	Photo1.Draw();*/
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);
	
	
	/*initialwindow.RenderRectangle((27.0,17.0),(28.0,18.0),White,true);
	initialwindow.RenderText((27.0,17.0),(28.0,18.0),"LEFT",Black);
	initialwindow.RenderRectangle((28.5,17.0),(29.5,18.0),White,true);
	initialwindow.RenderText((28.5,17.0),(29.5,18.0),"RIGHT",Black);
	initialwindow.RenderRectangle((27.0,18.5),(29.5,19.5),White,true);
	initialwindow.RenderText((27,18.5),(29.5,19.5),"FIRE",Black);
	initialwindow.RenderRectangle(Position(0.0,0.0),Position(0.5,0.5),White,true);
	initialwindow.RenderText(Position(0.0,0.0),Position(0.5,0.5),"II",Red);*/
	
	BitMap para0(initialwindow);
	BitMap land0(initialwindow);
	BitMap died0(initialwindow);
	BitMap bullet0(initialwindow);
	BitMap para1(initialwindow);
	BitMap land1(initialwindow);
	BitMap died1(initialwindow);
	BitMap bullet1(initialwindow);
	BitMap para2(initialwindow);
	BitMap land2(initialwindow);
	BitMap died2(initialwindow);
	BitMap bullet2(initialwindow);
	BitMap para3(initialwindow);
	BitMap land3(initialwindow);
	BitMap died3(initialwindow);
	BitMap bullet3(initialwindow);
	BitMap para4(initialwindow);
	BitMap land4(initialwindow);
	BitMap died4(initialwindow);
	BitMap bullet4(initialwindow);
	BitMap para5(initialwindow);
	BitMap land5(initialwindow);
	BitMap died5(initialwindow);
	BitMap bullet5(initialwindow);
	BitMap para6(initialwindow);
	BitMap land6(initialwindow);
	BitMap died6(initialwindow);
	BitMap bullet6(initialwindow);
	BitMap para7(initialwindow);
	BitMap land7(initialwindow);
	BitMap died7(initialwindow);
	BitMap bullet7(initialwindow);
	BitMap para8(initialwindow);
	BitMap land8(initialwindow);
	BitMap died8(initialwindow);
	BitMap bullet8(initialwindow);
	BitMap para9(initialwindow);
	BitMap land9(initialwindow);
	BitMap died9(initialwindow);
	BitMap bullet9(initialwindow);

for(l=0;l<=10;l++){
left1[l]=0;
bullets[l]=0;}

 nonblock(NB_ENABLE);
while (1)
{
srand((unsigned int)time((time_t *)NULL));
for(i=0;i<2;i++){//for random places where soilders drops
 random1[i] = rand()%25;} //define variables as global and float    ....here lengthint needed as % works with int ...length n lengthint will hv same value
for(j=0.0;j<LENGTH+10;j+=1.0) //0.1 is increment check if smaller increment is needed
    {
	BitMap Photo_heli(initialwindow);
	Position Photo_heliPosition=Position(j,0.0);//height of helicopter is 2.0
	Photo_heli.SetPosition(Photo_heliPosition);
	Photo_heli.Draw();
	m=j;
 for(i=0;i<2;i++)//drawing photograph of soldiers
 {
  if(random1[i]==m && m<=LENGTHINT)
  {
   if(k==10){//initialize k as global variable and it is 0 
	k=0;}//after 21 soldiers it overwrites assuming 21 soilders reach canon or die in way
	soldierx[k]=random1[i];
	soldiery[k]=2.0;
	left1[k]=1;//whether a particular soilder has to come down intial val is 0
	k++;
  }
}


for(l=0;l<9;l++){

 if(left1[l]==1)//checking whether soldier has to come down n alive by default v set it to 0 means not yet started to fall
     {
	soldiery[l]+=1.0;
	
	if(l==0){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para0.SetPosition(Photo_paraPosition);
	para0.Draw();}
	if(l==1){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para1.SetPosition(Photo_paraPosition);
	para1.Draw();}
	if(l==2){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para2.SetPosition(Photo_paraPosition);
	para2.Draw();}
	if(l==3){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para3.SetPosition(Photo_paraPosition);
	para3.Draw();}
	if(l==4){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para4.SetPosition(Photo_paraPosition);
	para4.Draw();}
	if(l==5){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para5.SetPosition(Photo_paraPosition);
	para5.Draw();}
	if(l==6){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para6.SetPosition(Photo_paraPosition);
	para6.Draw();}
	if(l==7){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para7.SetPosition(Photo_paraPosition);
	para7.Draw();}
	if(l==8){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para8.SetPosition(Photo_paraPosition);
	para8.Draw();}
	if(l==9){
	Position Photo_paraPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	para9.SetPosition(Photo_paraPosition);
	para9.Draw();}

	if(soldiery[l]>=HEIGHT-1)//checking if soldier reached bottom
	{
	left1[l]=2;//2 indicates it is at ground
	}
   }
 
 if(left1[l]==2)//2 indicates it is at ground
      {
	if (soldierx[l]>11.5)
	{
      	soldierx[l]-=2.0;
	}
	else if (soldierx[l]<13.5)
	{
      	soldierx[l]+=2.0;
	}
	else if (soldierx[l]>=11.5&&soldierx[l]<=13.5)
	 {
	 reached++;
	 left1[l]=4;
	 if(reached==5){//assuming if 5 reaches game ends
	   endwindow();//this will manage task of ending the program
	    }
	}

	if(l==0){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land0.SetPosition(Photo_landPosition);
	land0.Draw();}
	if(l==1){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land1.SetPosition(Photo_landPosition);
	land1.Draw();}
	if(l==2){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land2.SetPosition(Photo_landPosition);
	land2.Draw();}
	if(l==3){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land3.SetPosition(Photo_landPosition);
	land3.Draw();}
	if(l==4){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land4.SetPosition(Photo_landPosition);
	land4.Draw();}
	if(l==5){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land5.SetPosition(Photo_landPosition);
	land5.Draw();}
	if(l==6){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land6.SetPosition(Photo_landPosition);
	land6.Draw();}
	if(l==7){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land7.SetPosition(Photo_landPosition);
	land7.Draw();}
	if(l==8){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land8.SetPosition(Photo_landPosition);
	land8.Draw();}
	if(l==9){
	Position Photo_landPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	land9.SetPosition(Photo_landPosition);
	land9.Draw();}


   }

	
if(left1[l]==3)//checking whether soldier has to come down not alive 
	{
	soldiery[l]+=0.2;//increament can be changed to move dead soldier faster
	
	if(l==0){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died0.SetPosition(Photo_diedPosition);
	died0.Draw();}
	if(l==1){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died1.SetPosition(Photo_diedPosition);
	died1.Draw();}
	if(l==2){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died2.SetPosition(Photo_diedPosition);
	died2.Draw();}
	if(l==3){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died3.SetPosition(Photo_diedPosition);
	died3.Draw();}
	if(l==4){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died4.SetPosition(Photo_diedPosition);
	died4.Draw();}
	if(l==5){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died5.SetPosition(Photo_diedPosition);
	died5.Draw();}
	if(l==6){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died6.SetPosition(Photo_diedPosition);
	died6.Draw();}
	if(l==7){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died7.SetPosition(Photo_diedPosition);
	died7.Draw();}
	if(l==8){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died8.SetPosition(Photo_diedPosition);
	died8.Draw();}
	if(l==9){
	Position Photo_diedPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	died9.SetPosition(Photo_diedPosition);
	died9.Draw();}

	}
}
/*	q:
	a=initialwindow.SetMouseClickCallback(check);

 /*  if (a==0)
	{
	goto q;
	}
*/
usleep(1);
  i=kbhit();
usleep(100);
if(i!=0){
p=fgetc(stdin);
     if(p==32){//space to fire
	if(r==10){
	    r=0;
	  }
	bullets[r]=1;
	bulleta[r]=x;
	bulletx[r]=canonx;
	bullety[r]=canony;
	r++;
    }

    if((p==107 || p==75)&& x>=20){//k for right
	x--;
    }

   else if((p==106 || p==74) && x<=60){//j for left
	x++;
    }
   else if(p==27){//esc to exit
	endwindow();
    }

   else if(p==119 || p==87){//w to pause
	initialwindow.RenderText(Position(8.0,10.0),Position(17.0,13.0),"PRESS ANY KEY TO START",Black);
	getch();
	initialwindow.RenderRectangle(Position(8.0,10.0),Position(17.0,13.0),White,false);
}   
}

	/*initialwindow.RenderLine(Position(12.5,19.0),Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Blue, 0.1);
	initialwindow.RenderLine(Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Position(canonx,canony),White, 0.1);*/
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),White, 0.1);
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);

	if(reached==0){
	initialwindow.RenderText(Rectanglebase + Position(-0.5,-0.5),Rectanglebase + Position(0.5,0.0),"0",Black);}
	if(reached==1){
	initialwindow.RenderText(Rectanglebase + Position(-0.5,-0.5),Rectanglebase + Position(0.5,0.0),"1",Black);}	
	if(reached==2){
	initialwindow.RenderText(Rectanglebase + Position(-0.5,-0.5),Rectanglebase + Position(0.5,0.0),"2",Black);}	
	if(reached==3){
	initialwindow.RenderText(Rectanglebase + Position(-0.5,-0.5),Rectanglebase + Position(0.5,0.0),"3",Black);}	
	if(reached==4){
	initialwindow.RenderText(Rectanglebase + Position(-0.5,-0.5),Rectanglebase + Position(0.5,0.0),"4",Black);}	

	angle=x*3.14/40;
	canonx=12.5+1.5*sin(angle);
	canony=14.0+1.5*cos(angle);
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),Black, 0.1);
	
  for(u=0;u<10;u++){

//	sprintf(ch,"bullet%d",u);	
	if(bullets[u]==1)//bullet moving on
	{
	bulletx[u]+=2.0*sin(bulleta[u]*3.14/40);
	bullety[u]-=2.0*cos(bulleta[u]*3.14/40);

	if(u==0){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet0.SetPosition(bulletPosition);
	bullet0.Draw();}
	if(u==1){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet1.SetPosition(bulletPosition);
	bullet1.Draw();}
	if(u==2){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet2.SetPosition(bulletPosition);
	bullet2.Draw();}
	if(u==3){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet3.SetPosition(bulletPosition);
	bullet3.Draw();}
	if(u==4){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet4.SetPosition(bulletPosition);
	bullet4.Draw();}
	if(u==5){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet5.SetPosition(bulletPosition);
	bullet5.Draw();}
	if(u==6){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet6.SetPosition(bulletPosition);
	bullet6.Draw();}
	if(u==7){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet7.SetPosition(bulletPosition);
	bullet7.Draw();}
	if(u==8){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet8.SetPosition(bulletPosition);
	bullet8.Draw();}
	if(u==9){
	Position bulletPosition=Position(soldierx[l],soldiery[l]);//soldier y coordinate should b initialized to 2.0
	bullet9.SetPosition(bulletPosition);
	bullet9.Draw();}
	
	}

	if(bulletx[u]<=0.0||bulletx[u]>=25.0||bullety[u]<=15.0)
	{
	bullets[u]=2;
	}
    }	
for(u=0;u<10;u++)//for each bullet
{
    for(v=0;v<10;v++)//for each soldier
     {
	if((bulletx[u]>=(soldierx[v]-0.2)&&bulletx[u]<=(soldierx[v]+0.2))&&(bullety[u]>=(soldiery[v]-0.2)&&bullety[u]<=(soldiery[v]+0.2)))
	{
	score+=20;//each soldier shot makes score increase by 20
	bullets[u]=2;
	left1[v]=3;
	}
     }
}
Photo_heli.Erase();

para0.Erase();
land0.Erase();
died0.Erase();
bullet0.Erase();
para1.Erase();
land1.Erase();
died1.Erase();
bullet1.Erase();
para2.Erase();
land2.Erase();
died2.Erase();
bullet2.Erase();
para3.Erase();
land3.Erase();
died3.Erase();
bullet3.Erase();
para4.Erase();
land4.Erase();
died4.Erase();
bullet4.Erase();
para5.Erase();
land5.Erase();
died5.Erase();
bullet5.Erase();
para6.Erase();
land6.Erase();
died6.Erase();
bullet6.Erase();
para7.Erase();
land7.Erase();
died7.Erase();
bullet7.Erase();
para8.Erase();
land8.Erase();
died8.Erase();
bullet8.Erase();
para9.Erase();
land9.Erase();
died9.Erase();
bullet9.Erase();
}}
nonblock(NB_DISABLE);
}


