#include <iostream>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include "circle.h"
#include "assert.h"
#include "ezwin.h"
#include "bitmap.h"
#define LENGTH 25.0
#define HEIGHT 15.0
#define LENGTHINT 25

using namespace std;

int a,i=0,m,p,k,l,r=0,u,v,x=60,reached=0,score=0;
int left1[10],bullets[10],random1[2];
float angle,canonx,canony,j;
float soldierx[10],soldiery[10],bulletx[10],bullety[10],bulleta[10];
char s[4],ch[10],ch_para[10],ch_land[10],ch_died[10];

void startwindow();
void game();
void endwindow();

SimpleWindow initialwindow("Paratroopers",LENGTH,HEIGHT,Position(0.0,0.0));

/*int check(const Position &p)
{
int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=27.0&&x<=28.0)&&(y>=17.0&&y<=18.0))//checking whether click is in box left
return 3; 
else if((x>=28.5&&x<=29.5)&&(y>=17.0&&y<=18.0))//checking whether click is in box right
return 2;
else if((x>=27.0&&x<=18.5)&&(y>=29.5&&y<=19.5))//checking whether click is in box fire
return 1;
else return 0;
}*/

/*int check2(const Position &p)
{
	int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=0.0&&x<=0.5)&&(y>=0.0&&y<=0.5))
{c=1;}
else c= 0;
}*/
char getch() 
{
        char buf = 0;
        struct termios old = {0};
        if (tcgetattr(0, &old) < 0)
                perror("tcsetattr()");
        old.c_lflag &= ~ICANON;
        old.c_lflag &= ~ECHO;
        old.c_cc[VMIN] = 1;
        old.c_cc[VTIME] = 0;
        if (tcsetattr(0, TCSANOW, &old) < 0)
                perror("tcsetattr ICANON");
        if (read(0, &buf, 1) < 0)
                perror ("read()");
        old.c_lflag |= ICANON;
        old.c_lflag |= ECHO;
        if (tcsetattr(0, TCSADRAIN, &old) < 0)
                perror ("tcsetattr ~ICANON");
        return (buf);
}

int kbhit(void)
{
  struct termios oldt, newt;
  int ch;
  int oldf;
 
  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ICANON | ECHO);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
  fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
 
  ch = getchar();
  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
  fcntl(STDIN_FILENO, F_SETFL, oldf);
  if(ch != EOF)
  {
    ungetc(ch, stdin);
    return 1;
  }
 
  return 0;
}


int ApiMain(){
	SimpleWindow initialwindow("Paratroopers",LENGTH,HEIGHT,Position(0.0,0.0));
	initialwindow.Open();
	assert(initialwindow.GetStatus()==WindowOpen);	
while(1){
while(1){
sleep(1);
i=kbhit();
if(i!=0){
usleep(1000);
  p=getch();
    /* if(p==32){//space to fire
	if(r==10){
	    r=0;
	  }
	bullets[r]=1;
	bulleta[r]=x;
	bulletx[r]=canonx;
	bullety[r]=canony;
	r++;
    }*/

    if(p==106&& x<=80){//j for left
	x--;
    }

   else if(p==107 && x>=40){//k for right
	x++;
    }
   /*else if(p==27){//esc to exit
	initialwindow.Close();
    }

   else if(p==113){//q to restart
	//startwindow();
    }

   else if(p==119){//w to pause
	initialwindow.RenderText(Position(8.0,10.0),Position(17.0,13.0),"PRESS ANY KEY TO START",Black);
	//getch();
	initialwindow.RenderRectangle(Position(8.0,10.0),Position(17.0,13.0),White,false);
}   */
}

	/*initialwindow.RenderLine(Position(12.5,19.0),Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Blue, 0.1);
	initialwindow.RenderLine(Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Position(canonx,canony),White, 0.1);*/
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),White, 0.1);
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);
	angle=x*3.14/40;
	canonx=12.5+cos(angle);
	canony=14.0+sin(angle);
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),Black, 0.1);
}
}
}
