#include <iostream>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "circle.h"
#include "assert.h"
#include "ezwin.h"
#include "bitmap.h"
#define LENGTH 25.0
#define HEIGHT 15.0
#define LENGTHINT 25

using namespace std;

int m,p,i=0,k,l,r=0,u,v,x=40,reached=0,score=0;
int left1[10],bullets[10],random1[2];
float angle,canonx,canony,j;
float soldierx[10],soldiery[10],bulletx[10],bullety[10],bulleta[10];
char s[4],a;

SimpleWindow initialwindow("Paratroopers",LENGTH,HEIGHT,Position(0.0,0.0));

int NB_ENABLE=0,NB_DISABLE=1;

void nonblock(int state)
{
    struct termios ttystate;
 
    //get the terminal state
    tcgetattr(STDIN_FILENO, &ttystate);
 
    if (state==NB_ENABLE)
    {
        //turn off canonical mode
        ttystate.c_lflag &= ~ICANON;
        //minimum of number input read.
        ttystate.c_cc[VMIN] = 1;
    }
    else if (state==NB_DISABLE)
    {
        //turn on canonical mode
        ttystate.c_lflag |= ICANON;
    }
    //set the terminal attributes.
    tcsetattr(STDIN_FILENO, TCSANOW, &ttystate);
 
}
int kbhit()
{
    struct timeval tv;
    fd_set fds;
    tv.tv_sec = 0;
    tv.tv_usec = 0;
    FD_ZERO(&fds);
    FD_SET(STDIN_FILENO, &fds); //STDIN_FILENO is 0
    select(STDIN_FILENO+1, &fds, NULL, NULL, &tv);
    return FD_ISSET(STDIN_FILENO, &fds);
}


int ApiMain(){
 nonblock(NB_ENABLE);
while(1){
  i=kbhit();
if(i!=0){
p=fgetc(stdin);
     if(p==32){//space to fire
	if(r==10){
	    r=0;
	  }
	bullets[r]=1;
	bulleta[r]=x;
	bulletx[r]=canonx;
	bullety[r]=canony;
	r++;
    }

    if(p==107&& x>=20){//k for right
	x--;
    }

   else if(p==106 && x<=60){//j for left
	x++;
    }
   /*else if(p==27){//esc to exit
	initialwindow.Close();
    }

   else if(p==113){//q to restart
	startwindow();
    }
*/
   else if(p==119){//w to pause
	initialwindow.RenderText(Position(8.0,10.0),Position(17.0,13.0),"PRESS ANY KEY TO START",Black);
	sleep(2);
	initialwindow.RenderRectangle(Position(8.0,10.0),Position(17.0,13.0),White,false);
}
}

	/*initialwindow.RenderLine(Position(12.5,19.0),Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Blue, 0.1);
	initialwindow.RenderLine(Position(canonx+(canonx-12.5)/2,canony+(canony-19.0)/2),Position(canonx,canony),White, 0.1);*/
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),White, 0.1);
	Position Rectanglebase=Position(0.5*LENGTH,HEIGHT);//Center base of rectangle
	Position CircleCenter=Rectanglebase + Position(0.0,-1.0);//1.0 is height of ractangle
	CircleShape C(initialwindow,CircleCenter,Blue,2);
	C.Draw();
	Position UpperCorner=Rectanglebase + Position(-1.0, -1.0);//check the length 2 len 2 height
	Position LowerCorner=Rectanglebase + Position(1.0, 0.0);
	initialwindow.RenderRectangle(UpperCorner,LowerCorner,Blue,true);
	
	angle=x*3.14/40;
	canonx=12.5+1.5*sin(angle);
	canony=14.0+1.5*cos(angle);
	initialwindow.RenderLine(Position(12.5,14.0),Position(canonx,canony),Black, 0.1);

}nonblock(NB_DISABLE);
}
