#include <iostream>
#include <ctime>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <fstream>
#include "circle.h"
#include "assert.h"
#include "ezwin.h"
#include "bitmap.h"
#include "keydet.h"
#include "game.h"
#include "end.h"
#define LENGTH 25.0
#define HEIGHT 15.0
#define LENGTHINT 25

using namespace std;

/*int check(const Position &p)
{
int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=27.0&&x<=28.0)&&(y>=17.0&&y<=18.0))//checking whether click is in box left
return 3; 
else if((x>=28.5&&x<=29.5)&&(y>=17.0&&y<=18.0))//checking whether click is in box right
return 2;
else if((x>=27.0&&x<=18.5)&&(y>=29.5&&y<=19.5))//checking whether click is in box fire
return 1;
else return 0;
}*/

/*int check2(const Position &p)
{
	int x=0,y=0;
x=p.GetXDistance();
y=p.GetYDistance();
if((x>=0.0&&x<=0.5)&&(y>=0.0&&y<=0.5))
{c=1;}
else c= 0;
}

int kbhit()
{
  struct termios oldt, newt;
  int ch;
  int oldf;
 
  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ICANON | ECHO);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
  fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
 
  ch = getchar();
   p = ch;
  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
  fcntl(STDIN_FILENO, F_SETFL, oldf);
 
  if(ch != EOF)
  {
    ungetc(ch, stdin);
    return 1;
  }
 
  return 0;
}


int kbhit (void)
{
  struct timeval tv;
  fd_set rdfs;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  FD_ZERO(&rdfs);
  FD_SET (STDIN_FILENO, &rdfs);
 
  select(STDIN_FILENO+1, &rdfs, NULL, NULL, &tv);
  return FD_ISSET(STDIN_FILENO, &rdfs);
 
}*/

/*int game1(const Position &p)
{
int x=0,y=0;
x=p.GetXDistance();//check whether it is right command
y=p.GetYDistance();//check whether it is right command
if((x>=12.0&&x<=18.0)&&(y>=13.0&&y<=17.0))//checking whether click is in box
{b= 1;} 
else b= 0;
}*/

int ApiMain()//define it at last
{
	initialwindow.Open();
	assert(initialwindow.GetStatus()==WindowOpen);
	
	BitMap Photo_heli(initialwindow);//load the helicopter photo
	Photo_heli.Load("copter.xpm");
	assert(Photo_heli.GetStatus()==BitMapOkay);
		
	//loading part (photo.load) for 20 soldiers

	BitMap para0(initialwindow);
	para0.Load("paratrooper.xpm");
	assert(para0.GetStatus()==BitMapOkay);
	BitMap land0(initialwindow);//load the landed soldier photo
	land0.Load("landtrooper.xpm");
	assert(land0.GetStatus()==BitMapOkay);
	BitMap died0(initialwindow);//load the dead soldier photo
	died0.Load("diedtrooper.xpm");
	assert(died0.GetStatus()==BitMapOkay);
	BitMap bullet0(initialwindow);//load the bullet photo
	bullet0.Load("bullet.xpm");
	assert(bullet0.GetStatus()==BitMapOkay);

	BitMap para1(initialwindow);
	para1.Load("paratrooper.xpm");
	assert(para1.GetStatus()==BitMapOkay);
	BitMap land1(initialwindow);//load the landed soldier photo
	land1.Load("landtrooper.xpm");
	assert(land1.GetStatus()==BitMapOkay);
	BitMap died1(initialwindow);//load the dead soldier photo
	died1.Load("diedtrooper.xpm");
	assert(died1.GetStatus()==BitMapOkay);
	BitMap bullet1(initialwindow);//load the bullet photo
	bullet1.Load("bullet.xpm");
	assert(bullet1.GetStatus()==BitMapOkay);

	BitMap para2(initialwindow);
	para2.Load("paratrooper.xpm");
	assert(para2.GetStatus()==BitMapOkay);
	BitMap land2(initialwindow);//load the landed soldier photo
	land2.Load("landtrooper.xpm");
	assert(land2.GetStatus()==BitMapOkay);
	BitMap died2(initialwindow);//load the dead soldier photo
	died2.Load("diedtrooper.xpm");
	assert(died2.GetStatus()==BitMapOkay);
	BitMap bullet2(initialwindow);//load the bullet photo
	bullet2.Load("bullet.xpm");
	assert(bullet2.GetStatus()==BitMapOkay);

	BitMap para3(initialwindow);
	para3.Load("paratrooper.xpm");
	assert(para3.GetStatus()==BitMapOkay);
	BitMap land3(initialwindow);//load the landed soldier photo
	land3.Load("landtrooper.xpm");
	assert(land3.GetStatus()==BitMapOkay);
	BitMap died3(initialwindow);//load the dead soldier photo
	died3.Load("diedtrooper.xpm");
	assert(died3.GetStatus()==BitMapOkay);
	BitMap bullet3(initialwindow);//load the bullet photo
	bullet3.Load("bullet.xpm");
	assert(bullet3.GetStatus()==BitMapOkay);

	BitMap para4(initialwindow);
	para4.Load("paratrooper.xpm");
	assert(para4.GetStatus()==BitMapOkay);
	BitMap land4(initialwindow);//load the landed soldier photo
	land4.Load("landtrooper.xpm");
	assert(land4.GetStatus()==BitMapOkay);
	BitMap died4(initialwindow);//load the dead soldier photo
	died4.Load("diedtrooper.xpm");
	assert(died4.GetStatus()==BitMapOkay);
	BitMap bullet4(initialwindow);//load the bullet photo
	bullet4.Load("bullet.xpm");
	assert(bullet4.GetStatus()==BitMapOkay);

	BitMap para5(initialwindow);
	para5.Load("paratrooper.xpm");
	assert(para5.GetStatus()==BitMapOkay);
	BitMap land5(initialwindow);//load the landed soldier photo
	land5.Load("landtrooper.xpm");
	assert(land5.GetStatus()==BitMapOkay);
	BitMap died5(initialwindow);//load the dead soldier photo
	died5.Load("diedtrooper.xpm");
	assert(died5.GetStatus()==BitMapOkay);
	BitMap bullet5(initialwindow);//load the bullet photo
	bullet5.Load("bullet.xpm");
	assert(bullet5.GetStatus()==BitMapOkay);

	BitMap para6(initialwindow);
	para6.Load("paratrooper.xpm");
	assert(para6.GetStatus()==BitMapOkay);
	BitMap land6(initialwindow);//load the landed soldier photo
	land6.Load("landtrooper.xpm");
	assert(land6.GetStatus()==BitMapOkay);
	BitMap died6(initialwindow);//load the dead soldier photo
	died6.Load("diedtrooper.xpm");
	assert(died6.GetStatus()==BitMapOkay);
	BitMap bullet6(initialwindow);//load the bullet photo
	bullet6.Load("bullet.xpm");
	assert(bullet6.GetStatus()==BitMapOkay);

	BitMap para7(initialwindow);
	para7.Load("paratrooper.xpm");
	assert(para7.GetStatus()==BitMapOkay);
	BitMap land7(initialwindow);//load the landed soldier photo
	land7.Load("landtrooper.xpm");
	assert(land7.GetStatus()==BitMapOkay);
	BitMap died7(initialwindow);//load the dead soldier photo
	died7.Load("diedtrooper.xpm");
	assert(died7.GetStatus()==BitMapOkay);
	BitMap bullet7(initialwindow);//load the bullet photo
	bullet7.Load("bullet.xpm");
	assert(bullet7.GetStatus()==BitMapOkay);

	BitMap para8(initialwindow);
	para8.Load("paratrooper.xpm");
	assert(para8.GetStatus()==BitMapOkay);
	BitMap land8(initialwindow);//load the landed soldier photo
	land8.Load("landtrooper.xpm");
	assert(land8.GetStatus()==BitMapOkay);
	BitMap died8(initialwindow);//load the dead soldier photo
	died8.Load("diedtrooper.xpm");
	assert(died8.GetStatus()==BitMapOkay);
	BitMap bullet8(initialwindow);//load the bullet photo
	bullet8.Load("bullet.xpm");
	assert(bullet8.GetStatus()==BitMapOkay);

	BitMap para9(initialwindow);
	para9.Load("paratrooper.xpm");
	assert(para9.GetStatus()==BitMapOkay);
	BitMap land9(initialwindow);//load the landed soldier photo
	land9.Load("landtrooper.xpm");
	assert(land9.GetStatus()==BitMapOkay);
	BitMap died9(initialwindow);//load the dead soldier photo
	died9.Load("diedtrooper.xpm");
	assert(died9.GetStatus()==BitMapOkay);
	BitMap bullet9(initialwindow);//load the bullet photo
	bullet9.Load("bullet.xpm");
	assert(bullet9.GetStatus()==BitMapOkay);

	startwindow();
}
